# coding: utf-8

"""
    BoldSign API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Contact: support@boldsign.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from boldsign.models.phone_number import PhoneNumber
from typing import Optional, Set, Tuple
from typing_extensions import Self
import io
from pydantic import StrictBool
from typing import Union

class ChangeRecipient(BaseModel):
    """
    ChangeRecipient
    """ # noqa: E501
    new_signer_name: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="newSignerName")
    reason: Annotated[str, Field(min_length=1, strict=True)]
    order: Optional[Annotated[int, Field(le=50, strict=True, ge=1)]] = None
    new_signer_email: Optional[StrictStr] = Field(default=None, alias="newSignerEmail")
    old_signer_email: Optional[StrictStr] = Field(default=None, alias="oldSignerEmail")
    on_behalf_of: Optional[StrictStr] = Field(default=None, alias="onBehalfOf")
    phone_number: Optional[PhoneNumber] = Field(default=None, alias="phoneNumber")
    old_phone_number: Optional[PhoneNumber] = Field(default=None, alias="oldPhoneNumber")
    __properties: ClassVar[List[str]] = ["newSignerName", "reason", "order", "newSignerEmail", "oldSignerEmail", "onBehalfOf", "phoneNumber", "oldPhoneNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        arbitrary_types_allowed=True,
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    def to_json_form_params(self, excluded_fields: Set[str] = None) -> List[Tuple[str, str]]:
        data: List[Tuple[str, str]] = []

        for key, value in self.to_dict(excluded_fields).items():
            if isinstance(value, (int, str, bool)):
                data.append((key, value))
            elif isinstance(value, list):
                for index, item in enumerate(value):
                    if(isinstance(item, (int, str, bool))):
                        data.append((f'{key}[{index}]', item))
                    else:
                        data.append((key, json.dumps(value[index], ensure_ascii=False)))
            else:
                data.append((key, json.dumps(value, ensure_ascii=False)))

        return data

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChangeRecipient from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, excluded_fields: Set[str] = None) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChangeRecipient from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "newSignerName": obj.get("newSignerName"),
            "reason": obj.get("reason"),
            "order": obj.get("order"),
            "newSignerEmail": obj.get("newSignerEmail"),
            "oldSignerEmail": obj.get("oldSignerEmail"),
            "onBehalfOf": obj.get("onBehalfOf"),
            "phoneNumber": PhoneNumber.from_dict(obj["phoneNumber"]) if obj.get("phoneNumber") is not None else None,
            "oldPhoneNumber": PhoneNumber.from_dict(obj["oldPhoneNumber"]) if obj.get("oldPhoneNumber") is not None else None
        })
        return _obj

    @classmethod
    def init(cls, data: Any) -> Self:
        """
        Attempt to instantiate and hydrate a new instance of this class
        """
        if isinstance(data, str):
            data = json.loads(data)

        return cls.from_dict(data)

    @classmethod
    def openapi_types(cls) -> Dict[str, str]:
        return {
            "new_signer_name": "(str,)",
            "reason": "(str,)",
            "order": "(int,)",
            "new_signer_email": "(str,)",
            "old_signer_email": "(str,)",
            "on_behalf_of": "(str,)",
            "phone_number": "(PhoneNumber,)",
            "old_phone_number": "(PhoneNumber,)",
        }

    @classmethod
    def openapi_type_is_array(cls, property_name: str) -> bool:
        return property_name in [
        ]

